package com.offcn.api.study.studyapi;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import sun.security.krb5.internal.Ticket;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.STUDY;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 获取动态
 * 
 * @author liyy
 *
 */
public class moment extends STUDY implements API {
	
	public String parameter;//参数集合
	
	public String phone;//
	public String  ticket;
	
//	public String phone;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
		
			
	}
	
	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		ticket = MapUtil.getParameter(parameter, "offcn-ticket").trim();
	
		if ((!ticket.equals("")) && ticket.equals("ticket")) {
			ticket = Ticket;
			parameter = parameter.replace("\"offcn-ticket\":ticket", "\"offcn-ticket\":"+ "\"" + ticket +"\"" );
		}		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		//form 格式参数
	/*	Map<String,String> m=new HashMap<String,String>();
		m.put("user_id", user_id);
		m.put("image", user_id);
		m.put("appid","tiku");
		m.put("sign", TK.GetSignValue(parameter));
		
		Map<String,String> token=new HashMap<String,String>();
		token.put("Authorization", tk_token);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setFile("1.png");
		myRequest.setFormParameter(m);
		myRequest.setUrl(Url);
		myRequest.setHeaders(token);
		myRequest.setRequest(Request);*/

		//parameter = MapUtil.getValue("parameter", data);
		
		//Map<String,String> cookies=new HashMap<String,String>();
		//cookies.put("PHPSESSID", PHPSESSID);
		/*Map<String,String> token=new HashMap<String,String>();
		token.put("Authorization", "token");*/
		Map<String,String> ticket=new HashMap<String,String>();
		ticket.put("offcn-ticket", Ticket);
		MyRequest myRequest=new MyRequest();
		myRequest.setParameter(parameter);
		myRequest.setUrl(Url);

		System.out.println("Url====" +Url);
		myRequest.setRequest(Request);
		myRequest.setHeaders(ticket);
		//myRequest.setCookies(cookies);
		
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";
		
		String json = re.asString();
		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
								
			if("0".equals(code)){
				
				//创建后数据库在哪个表
				//是否验证数据库
				if (!isProduct) {
				
					/*template_id=jp.getString("data.id").substring(0,jp.getString("data.id").length());
					
					System.out.println("template_id====="+ template_id );
					try {
						String sql="SELECT  deleted_at  FROM `n_package`  WHERE  id =  " + package_id;
						//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						System.out.println("after deleted_packate ============"+ rs_bankcard.getString("deleted_at"));
						if(rs_bankcard.getString("deleted_at").contains("2019") )
						{
							
							
						}else {
							result = result && false;
							failReason = failReason + "deleted_packate  is wrong;";
						}
						
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}*/
				}
			
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
